//! @file	main.cpp
//! @brief	WindowsDirectX̏

#include "main.h"
#include "SceneTitle.h"			//! ^Cg̃V[
#include "DrawMain.h"			//! Q[̃V[

//============================================================================
//WindowspOJϐ
//============================================================================
HWND					hWindow		= NULL;	//!< EChEnh
HINSTANCE				hInstance	= NULL;	//!< CX^X
RECT					rcClientRect;		//!< NCAg̈TCY

//============================================================================
//V[pOJϐ
//============================================================================
LPSCENE					pNowLoop;			//!< C[vp̃V[֐|C^
LPSCENE					pNowRelease;			//!< Jp̃V[֐|C^


//============================================================================
// ֐vg^Cv錾
//============================================================================
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);		//!< bZ[WvV[W

//============================================================================
//! AvP[ṼGg[֐
//! @param[in]		hInst			̃AṽCX^X
//! @param[in]		hPrevInst		ÕAṽCX^X(gĂȂ)
//! @param[in]		pCmdLine		R}hCz
//! @param[in]		nCmdShow		R}hCz̐
//! @retval			0				G[I
//! @retval			̂ق		I
//! @brief			̊֐n܂
//!
//! 				EChE̓o^A쐬ADirectXAbZ[W[vADirectXJ̏
//============================================================================
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int nCmdShow)
{
	HWND hWnd = NULL;		//ꎞIȃEChEnh
	MSG msg;				//bZ[W󂯎p

	//[[NĎ
	MEMLEAKCHECK();

	// EChȄ
	static char szAppName[] = "pTv";
	WNDCLASSEX wc;
	wc.cbSize			= sizeof(wc);							//\̂̃TCY
	wc.style			= CS_HREDRAW | CS_VREDRAW;				//X^C
	wc.lpfnWndProc		= WndProc;								//bZ[WvV[W̃AhX
	wc.cbClsExtra		= 0;									//g
	wc.cbWndExtra		= 0;									//gEChE
	wc.hInstance		= hInst;								//CX^X
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);		//^Cgo[̃ACR
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			//J[\
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);	//wiF
	wc.lpszMenuName		= NULL;									//j[̃\[X
	wc.lpszClassName	= szAppName;							//AvP[V
	wc.hIconSm			= LoadIcon(NULL, IDI_ASTERISK);			//gJ[\

	//EChEo^
	if(!RegisterClassEx(&wc))
		return 0;

	//EChETCY̒(ʂɍ쐬ƃ^Cgo[ȂǂŃNCAg̈悪ȂȂ)
	rcClientRect.right	= WINDOW_WIDTH;
	rcClientRect.bottom = WINDOW_HEIGHT;
	AdjustWindowRect(&rcClientRect,			//EChẼTCY
					WS_OVERLAPPEDWINDOW,	//EChẼX^C
					FALSE					//j[̗L
					);

	//EChE쐬
	hWnd = CreateWindow(szAppName,								//AvP[V(wc.lpszClassNameƈꏏȂƑʖ)
						szAppName,								//^Cgo[̕
						WS_OVERLAPPEDWINDOW,					//EChẼX^C
						CW_USEDEFAULT, CW_USEDEFAULT,			//EChÊwCx
						rcClientRect.right - rcClientRect.left,	//EChE̕
						rcClientRect.bottom - rcClientRect.top,	//EChE̍
						NULL, NULL, hInst, NULL);
	if(hWnd == NULL)
		return 0;

	ShowWindow(hWnd, SW_SHOW);									//EChE̕\
	UpdateWindow(hWnd);											//EChE̍XV

	hWindow = hWnd;												//O[oϐɊi[
	hInstance = hInst;											//O[oϐɊi[


	//=================================
	//ŏɍsV[̂
	pNowLoop = TitleInit;
	//=================================

	// bZ[W[v
	ZeroMemory(&msg, sizeof(msg));
	while(msg.message != WM_QUIT)
	{
		//bZ[W邩ׂ
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);					//bZ[W̕ϊ
			DispatchMessage(&msg);					//bZ[W̊蓖
		}
		else
		{
			//=================================
			//V[̏
			pNowLoop = (LPSCENE)pNowLoop();
			if(pNowLoop == NULL)
				break;
			//=================================

			//CPULȂ悤OS֗Dxn
			Sleep(1);
		}
	}

	//=================================
	//V[̊J
	pNowRelease();
	//=================================

	return (int)msg.wParam;
}



//============================================================================
//! bZ[WvV[W
//! @param[in]		hWnd		EChEnh
//! @param[in]		uMsg		EChEbZ[W
//! @param[in]		wParam		EChEbZ[Wp[^P
//! @param[in]		lParam		EChEbZ[Wp[^Q
//! @retval			1			ʏI
//! @retval			0			炩̏ꂽ
//! @brief			WindowProc()Ă΂
//!					WindowProc()ȊOŃAvP[VL̏ɏǉĎg
//============================================================================
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	//AvŗLvV[Wŏ
	if(!MyWndProc(hWnd,uMsg,wParam,lParam))
		return 0;
	
	switch(uMsg)
	{
		//EChEƂ
		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
		//L[ꂽƂ
		case WM_KEYDOWN:
			if(wParam == VK_ESCAPE)
				PostMessage(hWnd,WM_CLOSE,0,0);
			return 0;
	}

	//Ȃ΃ftHg̏s
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

